<?php
if (!defined('ABSPATH')) {
    exit;
}


use CBSD_App\Types\CBSD_App;
use CBSD_App\Types\CBSD_Module;
use CBSD_App\Types\CBSD_Request;

use function CBSD_Helpers\cbsd_get_option_bool;
use function CBSD_Helpers\cbsd_log_sqli;


class CBSD_SQLiProtection extends CBSD_Module
{
    public $endpoint;
    private $config;

    function __construct($config = [])
    {
        $this->endpoint = CBSD_App::$dashboardURL . '/api/log/logEntry';
        $this->config = $config;

    }

    function main(CBSD_Request $request)
    {
        if (!cbsd_get_option_bool('cbsd_sqli_active')) {
            return;
        }

        $patterns = [
            "/(?i)\b(?:database\W*\(|db_name\W*\(|information_schema|master\.\.sysdatabases|msdb|sys\.database_name|sysaux|northwind|pg_(?:catalog|toast)|tempdb|schema(?:_name\b|\W*\()|sqlite_(?:temp_)?master)\b/i",
            "/(?i)\b(?:a(?:dd(?:dat|tim)e|es_(?:de|en)crypt|s(?:cii(?:str)?|in)|tan2?)|b(?:enchmark|i(?:n_to_num|t_(?:and|count|length|x?or)))|c(?:har(?:acter)?_length|iel(?:ing)?|o(?:alesce|ercibility|llation|(?:mpres)?s|n(?:cat(?:_ws)?|nection_id|v(?:ert(?:_tz)?)?)|t)|r32|ur(?:(?:dat|tim)e|rent_(?:date|setting|time(?:stamp)?|user)))|d(?:a(?:t(?:abase(?:_to_xml)?|e(?:_(?:add|format|sub)|diff))|y(?:name|of(?:month|week|year)))|count|e(?:code|grees|s_(?:de|en)crypt)|ump)|e(?:lt|n(?:c(?:ode|rypt)|ds_?with)|x(?:p(?:ort_set)?|tract(?:value)?))|f(?:i(?:el|n)d_in_set|ound_rows|rom_(?:base64|days|unixtime))|g(?:e(?:ometrycollection|t(?:_(?:format|lock)|pgusername))|(?:r(?:eates|oup_conca)|tid_subse)t)|hex(?:toraw)?|i(?:fnull|n(?:et6?_(?:aton|ntoa)|s(?:ert|tr)|terval)|s(?:_(?:(?:free|used)_lock|ipv(?:4(?:_(?:compat|mapped))?|6)|n(?:ot(?:_null)?|ull)|superuser)|null))|json(?:_(?:a(?:gg|rray(?:_(?:elements(?:_text)?|length))?)|build_(?:array|object)|e(?:ac|xtract_pat)h(?:_text)?|object(?:_(?:agg|keys))?|populate_record(?:set)?|strip_nulls|t(?:o_record(?:set)?|ypeof))|b(?:_(?:array(?:_(?:elements(?:_text)?|length))?|build_(?:array|object)|object(?:_(?:agg|keys))?|e(?:ac|xtract_pat)h(?:_text)?|insert|p(?:ath_(?:(?:exists|match)(?:_tz)?|query(?:_(?:(?:array|first)(?:_tz)?|tz))?)|opulate_record(?:set)?|retty)|s(?:et(?:_lax)?|trip_nulls)|t(?:o_record(?:set)?|ypeof)))?|path)?|l(?:ast_(?:day|inser_id)|case|e(?:as|f)t|i(?:kel(?:ihood|y)|nestring)|o(?:_(?:from_bytea|put)|ad_file|ca(?:ltimestamp|te)|g(?:10|2)|wer)|pad|trim)|m(?:a(?:ke(?:_set|date)|ster_pos_wait)|d5|i(?:crosecon)?d|onthname|ulti(?:linestring|po(?:int|lygon)))|n(?:ame_const|ot_in|ullif)|o(?:ct(?:et_length)?|(?:ld_passwo)?rd)|p(?:eriod_(?:add|diff)|g_(?:client_encoding|(?:databas|read_fil)e|l(?:argeobject|s_dir)|sleep|user)|rocedure_analyse)|qu(?:arter|ery_to_xml|ote)|r(?:a(?:dians|nd|wtohex)|elease_lock|ow_(?:count|to_json)|pad|trim)|s(?:chema|e(?:c_to_time|ssion_user)|ha[12]?|in|oundex|pace|q(?:lite_(?:compileoption_(?:get|used)|source_id)|rt)|t(?:arts_?with|d(?:dev_(?:po|sam)p)?|r(?:_to_date|cmp))|ub(?:(?:dat|tim)e|str(?:ing(?:_index)?)?)|ys(?:date|tem_user))|t(?:ime(?:_(?:format|to_sec)|diff|stamp(?:add|diff)?)|o(?:_(?:base64|jsonb?)|n?char|(?:day|second)s)|r(?:im|uncate))|u(?:case|n(?:compress(?:ed_length)?|hex|i(?:str|x_timestamp)|likely)|(?:pdatexm|se_json_nul)l|tc_(?:date|time(?:stamp)?)|uid(?:_short)?)|var(?:_(?:po|sam)p|iance)|we(?:ek(?:day|ofyear)|ight_string)|xmltype|yearweek)[^0-9A-Z_a-z]*\(/i",
            "/(?i:sleep\(\s*?\d*?\s*?\)|benchmark\(.*?\,.*?\))/i",
            "/(?i)(?:select|;)[\s\x0b]+(?:benchmark|if|sleep)[\s\x0b]*?\([\s\x0b]*?\(?[\s\x0b]*?[0-9A-Z_a-z]+/i",
            "/(?i)[\"'`](?:[\s\x0b]*![\s\x0b]*[\"'0-9A-Z_-z]|;?[\s\x0b]*(?:having|select|union\b[\s\x0b]*(?:all|(?:distin|sele)ct))\b[\s\x0b]*[^\s\x0b])|\b(?:(?:(?:c(?:onnection_id|urrent_user)|database|schema|user)[\s\x0b]*?|select.*?[0-9A-Z_a-z]?user)\(|exec(?:ute)?[\s\x0b]+master\.|from[^0-9A-Z_a-z]+information_schema[^0-9A-Z_a-z]|into[\s\x0b\+]+(?:dump|out)file[\s\x0b]*?[\"'`]|union(?:[\s\x0b]select[\s\x0b]@|[\s\x0b\(0-9A-Z_a-z]*?select))|[\s\x0b]*?exec(?:ute)?.*?[^0-9A-Z_a-z]xp_cmdshell|[^0-9A-Z_a-z]iif[\s\x0b]*?\(/i",
            "/^(?i:-0000023456|4294967295|4294967296|2147483648|2147483647|0000012345|-2147483648|-2147483649|0000023456|2.2250738585072007e-308|2.2250738585072011e-308|1e309)$/i",
            "/(?i)[\s\x0b\(\)]case[\s\x0b]+when.*?then|\)[\s\x0b]*?like[\s\x0b]*?\(|select.*?having[\s\x0b]*?[^\s\x0b]+[\s\x0b]*?[^\s\x0b0-9A-Z_a-z]|if[\s\x0b]?\([0-9A-Z_a-z]+[\s\x0b]*?[<->~]/i",
            "/(?i)alter[\s\x0b]*?[0-9A-Z_a-z]+.*?char(?:acter)?[\s\x0b]+set[\s\x0b]+[0-9A-Z_a-z]+|[\"'`](?:;*?[\s\x0b]*?waitfor[\s\x0b]+(?:time|delay)[\s\x0b]+[\"'`]|;.*?:[\s\x0b]*?goto)/i",
            "/(?i:merge.*?using\s*?\(|execute\s*?immediate\s*?[\"'`]|match\s*?[\w(),+-]+\s*?against\s*?\()/i",
            "/(?i)union.*?select.*?from/i",
            "/(?i)select[\s\x0b]*?pg_sleep|waitfor[\s\x0b]*?delay[\s\x0b]?[\"'`]+[\s\x0b]?[0-9]|;[\s\x0b]*?shutdown[\s\x0b]*?(?:[#;\{]|\/\*|--)/i",
            "/(?i)\[?\$(?:n(?:e|in?|o[rt])|e(?:q|xists|lemMatch)|l(?:te?|ike)|mod|a(?:ll|nd)|(?:s(?:iz|lic)|wher)e|t(?:ype|ext)|x?or|div|between|regex|jsonSchema)\]?/i",
            "/(?i)create[\s\x0b]+(?:function|procedure)[\s\x0b]*?[0-9A-Z_a-z]+[\s\x0b]*?\([\s\x0b]*?\)[\s\x0b]*?-|d(?:eclare[^0-9A-Z_a-z]*?@|ynamic[\s\x0b]*?sql)[\s\x0b]*?[\"'`]/i",
            '/(?i)create[\s\x0b]+function[\s\x0b].+[\s\x0b]returns|;[\s\x0b]*?(?:alter|(?:(?:cre|trunc|upd)at|renam)e|d(?:e(?:lete|sc)|rop)|(?:inser|selec)t|load)\b[\s\x0b]*?(?:\(|\[[0-9A-Z_a-z]{2,})/',
            '/(?i)\b(?:(?:alter|(?:(?:cre|trunc|upd)at|renam)e|de(?:lete|sc)|(?:inser|selec)t|load)[\s\v]+(?:char|group_concat|load_file)\b[\s\v]*\(?|end[\s\v]*?;)|[\s\v\(]load_file[\s\v]*?\(|["\'`][\s\v]+regexp[^0-9A-Z_a-z]|["\'0-9A-Z_-z][\s\v]+as\b[\s\v]*["\'0-9A-Z_-z]+[\s\v]*\bfrom|^[^A-Z_a-z]+[\s\v]*?(?:(?:(?:(?:cre|trunc)at|renam)e|d(?:e(?:lete|sc)|rop)|(?:inser|selec)t|load)[\s\v]+[0-9A-Z_a-z]+|u(?:pdate[\s\v]+[0-9A-Z_a-z]+|nion[\s\v]*(?:all|(?:sele|distin)ct)\b)|alter[\s\v]*(?:a(?:(?:ggregat|pplication[\s\v]*rol)e|s(?:sembl|ymme)tri|[^\s\v]+[\s\v]*?a(?:ll|ble))|b(?:egin|lock|reak|order|etween|y|table))[\s\v]*?\b\w+[\s\v]*\()/',
            "/(?i)\/\*[\s\x0b]*?[!\+](?:[\s\x0b\(\)\-0-9=A-Z_a-z]+)?\*\//i",
            "/^(?:[^']*'|[^\"]*\"|[^`]*`)[\s\x0b]*;/i",
            "/(?i)1\.e[\(\),]/i",
            "/[\"'`][\[\{].*[\]\}][\"'`].*(::.*jsonb?)?.*(?:(?:@|->?)>|<@|\?[&\|]?|#>>?|[<>]|<-)|(?:(?:@|->?)>|<@|\?[&\|]?|#>>?|[<>]|<-)[\"'`][\[\{].*[\]\}][\"'`]|json_extract.*\(.*\)/i",
            // paranoia lvl 2
            "/(?i)!=|&&|\|\||>[=>]|<(?:<|=>?|>(?:[\s\x0b]+binary)?)|\b(?:(?:xor|r(?:egexp|like)|i(?:snull|like)|notnull)\b|collate(?:[^0-9A-Z_a-z]*?(?:U&)?[\"'`]|[^0-9A-Z_a-z]+(?:(?:binary|nocase|rtrim)\b|[0-9A-Z_a-z]*?_))|(?:likel(?:ihood|y)|unlikely)[\s\x0b]*\()|r(?:egexp|like)[\s\x0b]+binary|not[\s\x0b]+between[\s\x0b]+(?:0[\s\x0b]+and|(?:'[^']*'|\"[^\"]*\")[\s\x0b]+and[\s\x0b]+(?:'[^']*'|\"[^\"]*\"))|is[\s\x0b]+null|like[\s\x0b]+(?:null|[0-9A-Z_a-z]+[\s\x0b]+escape\b)|(?:^|[^0-9A-Z_a-z])in[\s\x0b\+]*\([\s\x0b\"0-9]+[^\(\)]*\)|[!<->]{1,2}[\s\x0b]*all\b/i",
            // R"((?i)[\s\x0b\"'-\)`]*?\b([0-9A-Z_a-z]+)\b[\s\x0b\"'-\)`]*?(?:=|<=>|(?:sounds[\s\x0b]+)?like|glob|r(?:like|egexp))[\s\x0b\"'-\)`]*?\b([0-9A-Z_a-z]+)\b)",
            "/(?i)\b(?:json(?:_[0-9A-Z_a-z]+)?|a(?:bs|(?:cos|sin)h?|tan[2h]?|vg)|c(?:eil(?:ing)?|h(?:a(?:nges|r(?:set)?)|r)|o(?:alesce|sh?|unt)|ast)|d(?:e(?:grees|default)|a(?:te|y))|exp|f(?:loor(?:avg)?|ormat|ield)|g(?:lob|group_concat)|h(?:ex|our)|i(?:f(?:null)?|if|n(?:str)?)|l(?:ast(?:_insert_rowid)?|ength|ike(?:l(?:ihood|y))?|n|o(?:ad_extension|g(?:10|2)?|wer(?:pi)?|cal)|trim)|m(?:ax|in(?:ute)?|o(?:d|nth))|n(?:ullif|ow)|p(?:i|ow(?:er)?|rintf|assword)|quote|r(?:a(?:dians|ndom(?:blob)?)|e(?:p(?:lace|eat)|verse)|round|trim|right)|s(?:i(?:gn|nh?)|soundex|q(?:lite_(?:compileoption_(?:get|used)|offset|source_id|version)|rt)|u(?:bstr(?:ing)?|m)|econd|sleep)|t(?:anh?|total(?:_changes)?|r(?:im|unc)|ypeof|time)|u(?:n(?:icode|likely)|(?:pp|s)er)|zeroblob|bin|v(?:alues|ersion)|week|year)[^0-9A-Z_a-z]*\(/i",
            "/(?i)(?:\/\*)+[\"'`]+[\s\x0b]?(?:--|[#\{]|\/\*)?|[\"'`](?:[\s\x0b]*(?:(?:x?or|and|div|like|between)[\s\x0b\-0-9A-Z_a-z]+[\(\)\+-\-<->][\s\x0b]*[\"'0-9`]|[!=\|](?:[\s\x0b!\+\-0-9=]+.*?[\"'\(`].*?|[\s\x0b!0-9=]+.*?[0-9]+)$|(?:like|print)[^0-9A-Z_a-z]+[\"'\(0-9A-Z_-z]|;)|(?:[<>~]+|[\s\x0b]*[^\s\x0b0-9A-Z_a-z]?=[\s\x0b]*|[^0-9A-Z_a-z]*?[\+=]+[^0-9A-Z_a-z]*?)[\"'`])|[0-9][\"'`][\s\x0b]+[\"'`][\s\x0b]+[0-9]|^admin[\s\x0b]*?[\"'`]|[\s\x0b\"'\(`][\s\x0b]*?glob[^0-9A-Z_a-z]+[\"'\(0-9A-Z_a-z]*?[0-9]{2,}|;|[^0-9A-Z_a-z]0(?:(?:-[A-Za-z0-9]+|`[0-9A-Z_a-z-]+|[A-Za-z0-9-_]+)[\s\x0b]*?(?:[!=\|]|\<|>|[\s\x0b0-9A-Z_a-z]+\b)|[0-9A-Z_a-z]+(?:[!=\|]|\s|\(|\)|[\s\x0b0-9A-Z_a-z]))|(?:(?:table|column)[\s\x0b]*(?:name|type|index))|((?:^[^\s]*[\s\x0b]*\d\*[^\"\(\)`]*\b(?!\s|:)(?:[^0-9A-Z_a-z]|[0-9A-Z_a-z]+)*[\s\x0b]*\d?\b)+|(?:table|column)[\s\x0b]*?(?:name|type|index))[\s\x0b]*|^[^\s]+\b[\s\x0b]*(?:table|column)[\s\x0b]*(?:name|type|index)/i",
            // '/(?i)(?:\(\s*select\s*|\(\s*?select\s+|select\s+distinct\s+\(\s*)|(?:where[\s\x0b]*?[\(\[\{]|(?:select[\s\x0b]*\(\s*)|(?:(?:select\s+distinct\s+)?[^\s]+[\s\x0b]+\(\s*[^\s]+[\s\x0b]*\)[\s\x0b]*|(?:between[\s\x0b]+|(?:case\s+when\s*|cast\s*\(?)[^\s]+[\s\x0b]*|(?:case\s+when\s*|cast\s*\()?)[^\s]+[\s\x0b]*\))/'
            "/(?i)^(?:[^']*?(?:'[^']*?'[^']*?)*?'|[^\"]*?(?:\"[^\"]*?\"[^\"]*?)*?\"|[^`]*?(?:`[^`]*?`[^`]*?)*?`)[\s\x0b]*([0-9A-Z_a-z]+)\b/i",
            "/^.*?\x5c['\"`](?:.*?['\"`])?\s*(?:and|or)\b/i",
            "/(?i)\W+\d*?\s*?\bhaving\b\s*?[^\s\-]/i",
            "/(?i)^'$/", // single quote
        ];

        $request = sanitize_text_field(wp_unslash($_SERVER['REQUEST_METHOD']));

        $params = ($request === 'POST') ? $_POST : $_GET;

        foreach ($params as $key => $value) {
            foreach ($patterns as $pattern) {
                if (preg_match($pattern, sanitize_text_field($value), $matches)) {
                    cbsd_log_sqli($matches[0], fn() => wp_die(wp_kses("<div style=\"text-align: center;font-size: 20px; font-weight: bold;\">Your request has been blocked</div></div><footer style=\"font-size: 10px; margin-top: 2.5rem;\">Powered by: <a href=\"https://securas.fr\">Cybershield</a></footer>", array (
                        'div' => array (
                            'style' => array (),
                        ),
                        'footer' => array (
                            'style' => array (),
                        ),
                        'a' => array (
                            'href' => array (),
                        ),
                    )), 403));
                }
            }
        }
    }

    function info()
    {
        $api_key = get_option('api_key');

        return [
            "id" => "1",
            "apiKey" => $api_key,
            "version" => "1.0.0",
            "name" => "SQL injection protection",
            "description" => "Sanitize requests and block any damage that can be caused by an SQLi"
        ];

    }

    function get_options()
    {
        return require_once __DIR__ . '/options.php';
    }

    function get_settings()
    {
        return [];
    }
}
?>